# coding: utf-8

"""
    Prevision.io

    Prevision.io Studio APIs  # noqa: E501

    OpenAPI spec version: 1.0.5
    Contact: web@prevision.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ProjectIdModeldeploymentsBody(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'experiment_id': 'str',
        'main_model_experiment_version_id': 'str',
        'main_model_id': 'str',
        'challenger_model_experiment_version_id': 'str',
        'challenger_model_id': 'str',
        'access_type': 'str',
        'description': 'str'
    }

    attribute_map = {
        'name': 'name',
        'experiment_id': 'experiment_id',
        'main_model_experiment_version_id': 'main_model_experiment_version_id',
        'main_model_id': 'main_model_id',
        'challenger_model_experiment_version_id': 'challenger_model_experiment_version_id',
        'challenger_model_id': 'challenger_model_id',
        'access_type': 'access_type',
        'description': 'description'
    }

    def __init__(self, name=None, experiment_id=None, main_model_experiment_version_id=None, main_model_id=None, challenger_model_experiment_version_id=None, challenger_model_id=None, access_type=None, description=None):  # noqa: E501
        """ProjectIdModeldeploymentsBody - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._experiment_id = None
        self._main_model_experiment_version_id = None
        self._main_model_id = None
        self._challenger_model_experiment_version_id = None
        self._challenger_model_id = None
        self._access_type = None
        self._description = None
        self.discriminator = None
        if name is not None:
            self.name = name
        if experiment_id is not None:
            self.experiment_id = experiment_id
        if main_model_experiment_version_id is not None:
            self.main_model_experiment_version_id = main_model_experiment_version_id
        if main_model_id is not None:
            self.main_model_id = main_model_id
        if challenger_model_experiment_version_id is not None:
            self.challenger_model_experiment_version_id = challenger_model_experiment_version_id
        if challenger_model_id is not None:
            self.challenger_model_id = challenger_model_id
        if access_type is not None:
            self.access_type = access_type
        if description is not None:
            self.description = description

    @property
    def name(self):
        """Gets the name of this ProjectIdModeldeploymentsBody.  # noqa: E501


        :return: The name of this ProjectIdModeldeploymentsBody.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ProjectIdModeldeploymentsBody.


        :param name: The name of this ProjectIdModeldeploymentsBody.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def experiment_id(self):
        """Gets the experiment_id of this ProjectIdModeldeploymentsBody.  # noqa: E501


        :return: The experiment_id of this ProjectIdModeldeploymentsBody.  # noqa: E501
        :rtype: str
        """
        return self._experiment_id

    @experiment_id.setter
    def experiment_id(self, experiment_id):
        """Sets the experiment_id of this ProjectIdModeldeploymentsBody.


        :param experiment_id: The experiment_id of this ProjectIdModeldeploymentsBody.  # noqa: E501
        :type: str
        """

        self._experiment_id = experiment_id

    @property
    def main_model_experiment_version_id(self):
        """Gets the main_model_experiment_version_id of this ProjectIdModeldeploymentsBody.  # noqa: E501


        :return: The main_model_experiment_version_id of this ProjectIdModeldeploymentsBody.  # noqa: E501
        :rtype: str
        """
        return self._main_model_experiment_version_id

    @main_model_experiment_version_id.setter
    def main_model_experiment_version_id(self, main_model_experiment_version_id):
        """Sets the main_model_experiment_version_id of this ProjectIdModeldeploymentsBody.


        :param main_model_experiment_version_id: The main_model_experiment_version_id of this ProjectIdModeldeploymentsBody.  # noqa: E501
        :type: str
        """

        self._main_model_experiment_version_id = main_model_experiment_version_id

    @property
    def main_model_id(self):
        """Gets the main_model_id of this ProjectIdModeldeploymentsBody.  # noqa: E501


        :return: The main_model_id of this ProjectIdModeldeploymentsBody.  # noqa: E501
        :rtype: str
        """
        return self._main_model_id

    @main_model_id.setter
    def main_model_id(self, main_model_id):
        """Sets the main_model_id of this ProjectIdModeldeploymentsBody.


        :param main_model_id: The main_model_id of this ProjectIdModeldeploymentsBody.  # noqa: E501
        :type: str
        """

        self._main_model_id = main_model_id

    @property
    def challenger_model_experiment_version_id(self):
        """Gets the challenger_model_experiment_version_id of this ProjectIdModeldeploymentsBody.  # noqa: E501


        :return: The challenger_model_experiment_version_id of this ProjectIdModeldeploymentsBody.  # noqa: E501
        :rtype: str
        """
        return self._challenger_model_experiment_version_id

    @challenger_model_experiment_version_id.setter
    def challenger_model_experiment_version_id(self, challenger_model_experiment_version_id):
        """Sets the challenger_model_experiment_version_id of this ProjectIdModeldeploymentsBody.


        :param challenger_model_experiment_version_id: The challenger_model_experiment_version_id of this ProjectIdModeldeploymentsBody.  # noqa: E501
        :type: str
        """

        self._challenger_model_experiment_version_id = challenger_model_experiment_version_id

    @property
    def challenger_model_id(self):
        """Gets the challenger_model_id of this ProjectIdModeldeploymentsBody.  # noqa: E501


        :return: The challenger_model_id of this ProjectIdModeldeploymentsBody.  # noqa: E501
        :rtype: str
        """
        return self._challenger_model_id

    @challenger_model_id.setter
    def challenger_model_id(self, challenger_model_id):
        """Sets the challenger_model_id of this ProjectIdModeldeploymentsBody.


        :param challenger_model_id: The challenger_model_id of this ProjectIdModeldeploymentsBody.  # noqa: E501
        :type: str
        """

        self._challenger_model_id = challenger_model_id

    @property
    def access_type(self):
        """Gets the access_type of this ProjectIdModeldeploymentsBody.  # noqa: E501


        :return: The access_type of this ProjectIdModeldeploymentsBody.  # noqa: E501
        :rtype: str
        """
        return self._access_type

    @access_type.setter
    def access_type(self, access_type):
        """Sets the access_type of this ProjectIdModeldeploymentsBody.


        :param access_type: The access_type of this ProjectIdModeldeploymentsBody.  # noqa: E501
        :type: str
        """
        allowed_values = ["public", "fine_grained"]  # noqa: E501
        if access_type not in allowed_values:
            raise ValueError(
                "Invalid value for `access_type` ({0}), must be one of {1}"  # noqa: E501
                .format(access_type, allowed_values)
            )

        self._access_type = access_type

    @property
    def description(self):
        """Gets the description of this ProjectIdModeldeploymentsBody.  # noqa: E501


        :return: The description of this ProjectIdModeldeploymentsBody.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this ProjectIdModeldeploymentsBody.


        :param description: The description of this ProjectIdModeldeploymentsBody.  # noqa: E501
        :type: str
        """

        self._description = description

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ProjectIdModeldeploymentsBody, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ProjectIdModeldeploymentsBody):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
